//+------------------------------------------------------------------+
//|                                                           21.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"



extern double  Lots        = 0.1;
extern int     TakeProfit  = 50;
extern int     Step        = 50;
extern double  Multiplier  = 2;
extern int     Slippage    = 5;
extern int     Magic       = 123;
extern int     StopLoss    = 50;

int ticket;
double price, TP, lastlot, SL;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   if (Digits == 3 || Digits ==5)
   {
     TakeProfit *= 10;
     Step       *= 10;
     Slippage   *= 10;
     StopLoss   *= 10;
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if (CountTrades() == 0)
   {
      double ima = iMA(Symbol(), PERIOD_M1, 10, 0, MODE_SMA, PRICE_CLOSE, 1);
      
      if (Ask > ima)
      { 
         ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, SL, 0, "", Magic,0, Blue);
         if(ticket > 0)             
         {
            TP = NormalizeDouble(Ask + TakeProfit * Point, Digits);
            OrderModify(ticket, OrderProfit(), SL, TP, 0);
            SL = NormalizeDouble(Bid - StopLoss * Point, Digits);
            OrderModify(ticket, OrderProfit(), SL, TP, 0);      
            }
         }
         else if(Bid < ima)
         {
    ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, SL, 0, "", Magic,0, Red);
         if(ticket > 0)             
         {
            TP = NormalizeDouble(Ask + TakeProfit  * Point, Digits);
            OrderModify(ticket, OrderProfit(), SL, TP, 0);
             SL = NormalizeDouble(Bid - StopLoss * Point, Digits);
            OrderModify(ticket, OrderProfit(), SL, TP, 0);         
         }
       }
   }
   else
   {
       int order_type = FindLastOrderType();
       if (order_type == OP_BUY)
       {
           price = FindLastPrice(OP_BUY);
           if(Ask <= price - Step * Point)
           {
               lastlot = FindLastLots(OP_BUY);
               lastlot = NormalizeDouble(lastlot * Multiplier, 2);         
               ticket = OrderSend(Symbol(), OP_BUY, lastlot, Ask, Slippage, SL, 0, "", Magic, 0, Blue);
               if (ticket > 0)
                  ModifyOrders(OP_BUY);
           
           }
       }
       else if (order_type == OP_SELL)  
       {
           price = FindLastPrice(OP_SELL);
           if(Bid <= price + Step * Point)
           {
               lastlot = FindLastLots(OP_SELL);
               lastlot = NormalizeDouble(lastlot * Multiplier, 2);         
               ticket = OrderSend(Symbol(), OP_SELL, lastlot, Bid, Slippage, SL, 0, "", Magic, 0, Red);
               if (ticket > 0)
                  ModifyOrders(OP_SELL);
           
           }
       }
   }
   
   return(0);
}
//+------------------------------------------------------------------+
void ModifyOrders(int otype)
{
   double avgprice = 0,
          order_lots = 0;
   
   price = 0;
   for (int i=OrdersTotal()-1; i>=0; i--)
   {
       if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
       {
          if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && OrderType() == otype)
          {
             price += OrderProfit() * OrderLots();
             order_lots += OrderLots();          
          }
       }
   }
   
   avgprice = NormalizeDouble(price / order_lots, Digits);
   
   if (otype == OP_BUY) TP = NormalizeDouble(avgprice + TakeProfit*Point, Digits);
   if (otype == OP_SELL) TP = NormalizeDouble(avgprice - TakeProfit*Point, Digits);
   
   for (i=OrdersTotal()-1; i>=0; i--)
   {
       if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
       {
          if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && OrderType() == otype)
              OrderModify(OrderTicket(), OrderProfit(), SL, TP, 0);
          }
   }
   
} 
//+------------------------------------------------------------------+
double FindLastLots(int otype)
{
   double oldlots;
   int    oldticket;
   
   ticket = 0;
   for(int i = OrdersTotal()-1; i>=0; i--)
   {
       if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
       {
           if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && OrderType() == otype)
           {
               oldticket = OrderTicket();
               if(oldticket > ticket)
               {
                  oldlots = OrderLots();
                  ticket = oldticket;
               }           
           }   
       }
   }
   return(oldlots);      
}
//+------------------------------------------------------------------+
double FindLastPrice (int otype)
{
   double oldopenprice;
   int    oldticket;
   
   ticket = 0;
   
   for(int i=OrdersTotal()-1; i>=0; i--)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && OrderType() == otype)
         {
            oldticket = OrderTicket();
            if(oldticket > ticket)         
            {
               oldopenprice = OrderProfit();
               ticket = oldticket;               
            }             
         }
      }
   }          
   return(oldopenprice);     
}
//+------------------------------------------------------------------+
int FindLastOrderType()
{
   for (int i= OrdersTotal()-1; i>=0; i--)
   {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
           return(OrderType());         
      }  
   }
   return(-1);   
}   
//+------------------------------------------------------------------+


int CountTrades()
{
 int count = 0;
 for (int i=OrdersTotal()-1; i>=0; i-- )
 {
    if(OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
    {
       if(OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
          count++;
    }
    
  }   

  return(count);
} 





//+------------------------------------------------------------------+        